#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <windows.h>

#define NKF32103A
/*
#define TOMIME
#define GETKANJICODE
#define FILECONVERT1
#define FILECONVERT2
*/
#include "nkf.h"

/*
nkfdll
*/

unsigned char buff[65536];
unsigned char buff2[65536];
unsigned char buff3[65536];
unsigned char buff4[65536];
char *code[] = {"VtgJIS","EUC","ISO-2022-JP","UTF-8","UTF-16LE","UTF-16BE"};

    int n;
    BOOL sts;
    DWORD len;
    struct {
        DWORD size;
        LPCSTR copyrightA;
        LPCSTR versionA;
        LPCSTR dateA;
        DWORD functions;
    } fnc;

    void (CALLBACK *ToMime)(LPSTR outStr ,LPCSTR inStr);
    int (CALLBACK *NkfGetKanjiCode)(VOID);
    BOOL (WINAPI *GetNkfVersionSafeA)(LPSTR verStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
    BOOL (WINAPI *GetNkfVersionSafeW)(LPWSTR verStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
    BOOL (WINAPI *GetNkfSupportFunctions)(void *outStr,DWORD nBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/);
    BOOL (WINAPI *NkfConvertSafe)(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/, LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/);
    BOOL (WINAPI *EncodeSubjectSafe)(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/);
BOOL (WINAPI *GetNkfGuessA)(LPSTR outStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
BOOL (WINAPI *GetNkfGuessW)(LPWSTR outStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
void (CALLBACK *NkfFileConvert1)(LPCSTR fName);
BOOL (WINAPI *NkfFileConvert1SafeA)(LPCSTR fName,DWORD nBufferLength /*in TCHARs*/);
BOOL (WINAPI *NkfFileConvert1SafeW)(LPCWSTR fName,DWORD nBufferLength /*in TCHARs*/);
void (CALLBACK *NkfFileConvert2)(LPCSTR fInName,LPCSTR fOutName);
BOOL (WINAPI *NkfFileConvert2SafeA)(LPCSTR fInName,DWORD fInBufferLength /*in TCHARs*/,LPCSTR fOutName,DWORD fOutBufferLength /*in TCHARs*/);
BOOL (WINAPI *NkfFileConvert2SafeW)(LPCWSTR fInName,DWORD fInBufferLength /*in TCHARs*/,LPCWSTR fOutName,DWORD fOutBufferLength /*in TCHARs*/);
BOOL (WINAPI *NkfUsage)(LPSTR outStr,DWORD nBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/);


void dumpn(unsigned char *buff,unsigned n)
{
    int i;

    i = 0;
    if ( n == 0 ) {
        printf(":%x  len=%d\n",buff,n);
        return;
    }
    while ( n ) {
        if ( i == 0 ) {
            printf(":%x  ",buff);
        }
        printf("%02x ",*buff++);
        i++;
        if ( i == 16 ) {
            printf("\n");
            i = 0;
        }
        n--;
    }
    printf("\n");
}

void mimeencode(unsigned char *buff2)
{
    memset(buff,0,sizeof buff);
    EncodeSubject(buff,buff2);
    printf("EncodeSubject(%s)=%s\n",buff2,buff);
    if ( ToMime != NULL ) {
        memset(buff,0,sizeof buff);
        ToMime(buff,buff2);
        printf("ToMime(%s)=%s\n",buff2,buff);
    }
    if ( EncodeSubjectSafe != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = EncodeSubjectSafe(buff,sizeof buff,&len,buff2,strlen(buff2));
        printf("EncodeSubjectSafe(%s)=%d len=%d '%s'\n",buff,sts,len,buff);
        dumpn(buff2,strlen(buff2));
        dumpn(buff,len);
    }
}

void convert(char *arg,unsigned char *buff2,int l)
{
printf("l=%d\n",l);
    sts = SetNkfOption(arg);
    printf("SetNkfOption(%s)=%d\n",arg,sts);
    memset(buff,0,sizeof buff);
    *(buff2 + l) = 0;
    NkfConvert(buff,buff2);
    printf("NkfConvert(%s)=%s\n",buff2,buff);
    if ( NkfGetKanjiCode != NULL ) {
        n = NkfGetKanjiCode();
        printf("NkfGetKanjiCode()=%d %s\n",n,code[n]);
    }
    if ( NkfConvertSafe != NULL ) {
        sts = SetNkfOption(arg);
        printf("SetNkfOption(%s)=%d\n",arg,sts);
        memset(buff,0,sizeof buff);
        len = 0;
        sts = NkfConvertSafe(buff,sizeof buff,&len,buff2,l);
        printf("NkfConvertSafe(%x,%d,%x,\n%s\n,%d)=%d len=%d \n%s\n",buff,sizeof buff,&len,buff2,l,sts,len,buff);
        dumpn(buff2,l);
        dumpn(buff,len);
        if ( NkfGetKanjiCode != NULL ) {
            n = NkfGetKanjiCode();
            printf("NkfGetKanjiCode()=%d %s\n",n,code[n]);
        }
    }
}

void guess(unsigned char *buff2,DWORD l)
{
    char *g = "--guess";
    DWORD outlen;

    sts = SetNkfOption(g);
    printf("SetNkfOption(%s)=%d\n",g,sts);
    memset(buff,0,sizeof buff);
    if ( NkfConvertSafe != NULL ) {
        outlen = 0;
        NkfConvertSafe(buff,sizeof buff - 1,&outlen,buff2,l);
        printf("NkfConvertSafe(%s,%u,%u,%s,%u)=%s\n",buff,sizeof buff,outlen,buff2,l,buff);
        dumpn(buff2,l);
    } else {
        NkfConvert(buff,buff2);
        printf("NkfConvert(%s)=%s\n",buff2,buff);
        dumpn(buff2,strlen(buff2));
    }
/* 1 */
    if ( NkfGetKanjiCode != NULL ) {
        n = NkfGetKanjiCode();
        printf("NkfGetKanjiCode()=%d %s\n",n,code[n]);
    }
    if ( GetNkfGuessA != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfGuessA(buff,sizeof buff,&len);
        printf("GetNkfGuessA()=%d len=%d '%s'\n",sts,len,buff);
        dumpn(buff,len);
    }
printf("GetNkfGuessW(buff=%x,size=%u)::\n",buff,sizeof buff / sizeof(WCHAR),&len);
    if ( GetNkfGuessW != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfGuessW((LPWSTR)buff,sizeof buff / sizeof(WCHAR),&len);
        printf("GetNkfGuessW()=%d len=%d\n",sts,len);
        dumpn(buff,len * sizeof(WCHAR));
    }
/* 2 */
    if ( NkfGetKanjiCode != NULL ) {
        n = NkfGetKanjiCode();
        printf("NkfGetKanjiCode()=%d %s\n",n,code[n]);
    }
    if ( GetNkfGuessA != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfGuessA(buff,sizeof buff,&len);
        printf("GetNkfGuessA()=%d len=%d '%s'\n",sts,len,buff);
        dumpn(buff,len);
    }
printf("GetNkfGuessW(buff=%x,size=%u)::\n",buff,sizeof buff / sizeof(WCHAR),&len);
    if ( GetNkfGuessW != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfGuessW((LPWSTR)buff,sizeof buff / sizeof(WCHAR),&len);
        printf("GetNkfGuessW()=%d len=%d\n",sts,len);
        dumpn(buff,len * sizeof(WCHAR));
    }
}

void dumpf(char *f)
{
    FILE *fp;
    unsigned int n;

    fp = fopen(f,"rb");
    if ( fp == NULL ) return;
    n = fread(buff,1,sizeof buff,fp);
    fclose(fp);
    printf("dumpf(%s,%d)\n",f,n);
    dumpn(buff,n);
}

void mkfile(char *f,char *p)
{
    FILE *fp;

printf("mkfile(%s,%s)\n",f,p);
    fp = fopen(f,"w");
    if ( fp == NULL ) return;
    fputs(p,fp);
    fclose(fp);
    dumpf(f);
}

void file(char *arg2,char *arg3,unsigned char *buf)
{
    if ( NkfFileConvert1 != NULL ) {
            sts = SetNkfOption(arg2);
            printf("SetNkfOption(%s)=%d\n",arg2,sts);
            mkfile(arg3,buf);
            NkfFileConvert1(arg3);
            printf("NkfFileConvert1(%s)\n",arg3);
            dumpf(arg3);
    }
    if ( NkfFileConvert1SafeA != NULL ) {
            sts = SetNkfOption(arg2);
            printf("SetNkfOption(%s)=%d\n",arg2,sts);
            mkfile(arg3,buf);
            sts = NkfFileConvert1SafeA(arg3,strlen(arg3) + 1);
            printf("NkfFileConvert1SafeA(%s)=%d\n",arg3,sts);
            dumpf(arg3);
    }
    if ( NkfFileConvert1SafeW != NULL ) {
            sts = SetNkfOption(arg2);
            printf("SetNkfOption(%s)=%d\n",arg2,sts);
            mkfile(arg3,buf);
            sts = MultiByteToWideChar(CP_OEMCP,MB_PRECOMPOSED,arg3,-1,(wchar_t *)buff,sizeof(buff) / sizeof(wchar_t));
            printf("MultiByteToWideChar(%s)=%d\n",arg3,sts);
            dumpn(buff,(wcslen((wchar_t *)buff) + 1) * sizeof(wchar_t));
            sts = NkfFileConvert1SafeW((wchar_t *)buff,sizeof buff / sizeof(wchar_t) /*wcslen((wchar_t *)buff) + 1*/);
            dumpf(arg3);
            printf("NkfFileConvert1SafeW()=%d\n",sts);
            dumpf(arg3);
    }
}

void file2(char *arg2,char *arg3,char *arg4,unsigned char *buf)
{
    if ( NkfFileConvert2 != NULL ) {
            sts = SetNkfOption(arg2);
            printf("SetNkfOption(%s)=%d\n",arg2,sts);
            mkfile(arg3,buf);
            NkfFileConvert2(arg3,arg4);
            printf("NkfFileConvert1(%s,%s)\n",arg3,arg4);
            dumpf(arg3);
            dumpf(arg4);
    }
    if ( NkfFileConvert2SafeA != NULL ) {
            sts = SetNkfOption(arg2);
            printf("SetNkfOption(%s)=%d\n",arg2,sts);
            mkfile(arg3,buf);
            sts = NkfFileConvert2SafeA(arg3,strlen(arg3) + 1,arg4,strlen(arg4) + 1);
            printf("NkfFileConvert2SafeA(%s,%s)=%d\n",arg3,arg4,sts);
            dumpf(arg3);
            dumpf(arg4);
    }
    if ( NkfFileConvert2SafeW != NULL ) {
            sts = SetNkfOption(arg2);
            printf("SetNkfOption(%s)=%d\n",arg2,sts);
            mkfile(arg3,buf);
            sts = MultiByteToWideChar(CP_OEMCP,MB_PRECOMPOSED,arg3,-1,(wchar_t *)buff,sizeof(buff) / sizeof(wchar_t));
            printf("MultiByteToWideChar(%s)=%d\n",arg3,sts);
            dumpn(buff,(wcslen((wchar_t *)buff) + 1) * sizeof(wchar_t));
            sts = MultiByteToWideChar(CP_OEMCP,MB_PRECOMPOSED,arg4,-1,(wchar_t *)buff4,sizeof(buff4) / sizeof(wchar_t));
            printf("MultiByteToWideChar(%s)=%d\n",arg4,sts);
            dumpn(buff4,(wcslen((wchar_t *)buff4) + 1) * sizeof(wchar_t));
            sts = NkfFileConvert2SafeW((wchar_t *)buff,sizeof buff / sizeof(wchar_t) ,(wchar_t *)buff4,sizeof buff4 / sizeof(wchar_t));
            printf("NkfFileConvert2SafeW()=%d\n",sts);
            dumpf(arg3);
            dumpf(arg4);
    }
}

int main(int argc,char **argv)
{
    HMODULE lib;
    int l;

    setmode(fileno(stdin), O_BINARY);
    lib = LoadLibrary("nkf32.dll");
    printf("LoadLibrary(nkf32.dll) ");
    if ( lib == NULL ) {
        printf("fail\nreturn 1\n");
        return 1;
    }
    ToMime = (void (CALLBACK *)(LPSTR,LPCSTR))GetProcAddress(lib,"ToMime");
    if ( ToMime == NULL ) printf("ToMime == NULL ");
    NkfGetKanjiCode = (int (CALLBACK *)(VOID))GetProcAddress(lib,"NkfGetKanjiCode");
    if ( NkfGetKanjiCode == NULL ) printf("NkfGetKanjiCode == NULL ");
    GetNkfVersionSafeA = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfVersionSafeA");
    if ( GetNkfVersionSafeA == NULL ) printf("GetNkfVersionSafeA == NULL ");
    GetNkfVersionSafeW = (BOOL (WINAPI *)(LPWSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfVersionSafeW");
    if ( GetNkfVersionSafeW == NULL ) printf("GetNkfVersionSafeW == NULL ");
    GetNkfSupportFunctions = (BOOL (WINAPI *)(void *,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfSupportFunctions");
    if ( GetNkfSupportFunctions == NULL ) printf("GetNkfSupportFunctions == NULL ");
    EncodeSubjectSafe = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD,LPCSTR,DWORD))GetProcAddress(lib,"EncodeSubjectSafe");
    if ( EncodeSubjectSafe == NULL ) printf("EncodeSubjectSafe == NULL ");
    NkfConvertSafe = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD, LPCSTR,DWORD))GetProcAddress(lib,"NkfConvertSafe");
    if ( NkfConvertSafe == NULL ) printf("NkfConvertSafe == NULL ");
    GetNkfGuessA = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfGuessA");
    if ( GetNkfGuessA == NULL ) printf("GetNkfGuessA == NULL ");
    GetNkfGuessW = (BOOL (WINAPI *)(LPWSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfGuessW");
    if ( GetNkfGuessW == NULL ) printf("GetNkfGuessWe == NULL ");
    NkfFileConvert1 = (void (CALLBACK *)(LPCSTR))GetProcAddress(lib,"NkfFileConvert1");
    if ( NkfFileConvert1 == NULL ) printf("NkfFileConvert1 == NULL ");
    NkfFileConvert1SafeA = (BOOL (WINAPI *)(LPCSTR,DWORD))GetProcAddress(lib,"NkfFileConvert1SafeA");
    if ( NkfFileConvert1SafeA == NULL ) printf("NkfFileConvert1SafeA == NULL ");
    NkfFileConvert1SafeW = (BOOL (WINAPI *)(LPCWSTR,DWORD))GetProcAddress(lib,"NkfFileConvert1SafeW");
    if ( NkfFileConvert1SafeW == NULL ) printf("NkfFileConvert1SafeW == NULL ");
    NkfFileConvert2 = (void (CALLBACK *)(LPCSTR,LPCSTR))GetProcAddress(lib,"NkfFileConvert2");
    if ( NkfFileConvert2 == NULL ) printf("NkfFileConvert2 == NULL ");
    NkfFileConvert2SafeA = (BOOL (WINAPI *)(LPCSTR,DWORD,LPCSTR,DWORD))GetProcAddress(lib,"NkfFileConvert2SafeA");
    if ( NkfFileConvert2SafeA == NULL ) printf("NkfFileConvert2SafeA == NULL ");
    NkfFileConvert2SafeW = (BOOL (WINAPI *)(LPCWSTR,DWORD,LPCWSTR,DWORD))GetProcAddress(lib,"NkfFileConvert2SafeW");
    if ( NkfFileConvert2SafeW== NULL ) printf("NkfFileConvert2SafeW == NULL ");
    NkfUsage = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD))GetProcAddress(lib,"NkfUsage");
    if ( NkfUsage == NULL ) printf("NkfUsage == NULL ");
     printf("\n");

    if ( argc < 2 ) {
        printf(
"v\n"
" version\n"
"m input\n"
" mime encode\n"
"M\n"
" mime encode from stdin\n"
"c option input\n"
" convert\n"
"C option\n"
" convert from stdin\n"
"g input\n"
" guess\n"
"G\n"
" guess from stdin\n"
"f option file data\n"
" convert file\n"
"F\n"
" option file from stdin\n"
"2 option infile outfile data\n"
" convert file\n"
"#\n"
" option infile outfile from stdin\n"
"u\n"
" Usage\n"
        );
        return 0;
    }
    switch ( *argv[1] ) {
      case 'v':
        memset(buff,0,sizeof buff);
        GetNkfVersion(buff);
        printf("GetNkfVersion() '%s'\n",buff);
        if ( GetNkfVersionSafeA != NULL ) {
            memset(buff,0,sizeof buff);
            len = 0;
            sts = GetNkfVersionSafeA(buff,sizeof buff,&len);
            printf("GetNkfVersionSafeA()=%d len=%d '%s'\n",sts,len,buff);
        }
        if ( GetNkfVersionSafeW != NULL ) {
            memset(buff,0,sizeof buff);
            len = 0;
            sts = GetNkfVersionSafeW((LPWSTR)buff,sizeof buff / sizeof(WCHAR),&len);
            printf("GetNkfVersionSafeW()=%d len=%d\n",sts,len);
            dumpn(buff,len * sizeof(WCHAR));
        }
        if ( GetNkfSupportFunctions != NULL ) {
            len = 0;
            sts = GetNkfSupportFunctions(&fnc,sizeof fnc,&len);
            printf("GetNkfSupportFunctions()=%d len=%d\n",sts,len);
            printf("size=%u\n",fnc.size);
            printf("copyrightA='%s'\n",fnc.copyrightA);
            printf("versionA='%s'\n",fnc.versionA);
            printf("dateA='%s'\n",fnc.dateA);
            printf("functions=%d %x\n",fnc.functions,fnc.functions);
        }
        break;
      case 'm':
        if ( argc < 3 ) return 0;
        mimeencode(argv[2]);
        break;
      case 'M':
        if ( argc < 2 ) return 0;
        gets(buff2);
        mimeencode(buff2);
        break;
      case 'c':
        if ( argc < 4 ) return 0;
        convert(argv[2],argv[3],strlen(argv[3]));
        break;
      case 'C':
        if ( argc < 3 ) return 0;
        l = fread(buff2,1,sizeof buff2 - 1,stdin);
        convert(argv[2],buff2,l);
        break;
      case 'd':
        if ( argc < 3 ) return 0;
        l = fread(buff2,1,sizeof buff2 - 1,stdin);
printf("fread(buff2,1,sizeof buff2 - 1,stdin)=%d\n",l);
        convert(argv[2],buff2,l);
        break;
      case 'g':
        if ( argc < 3 ) return 0;
        guess(argv[2],strlen(argv[2]));
        break;
      case 'G':
        if ( argc < 2 ) return 0;
        l = fread(buff2,1,sizeof buff2,stdin);
        guess(buff2,l);
        break;
      case 'f':
        if ( argc < 5 ) return 0;
        file(argv[2],argv[3],argv[4]);
        break;
      case 'F':
        if ( argc < 4 ) return 0;
        fread(buff3,1,sizeof buff3,stdin);
        file(argv[2],argv[3],buff3);
        break;
      case '2':
        if ( argc < 6 ) return 0;
        file2(argv[2],argv[3],argv[4],argv[5]);
        break;
      case '#':
        if ( argc < 5 ) return 0;
        gets(buff3);
        file2(argv[2],argv[3],argv[4],buff3);
        break;
      case 'u':
        if ( NkfUsage != NULL ) {
            memset(buff,0,sizeof buff);
            len = 0;
            sts = NkfUsage(buff,sizeof buff,&len);
            printf("strlen(buff)=%d\n",strlen(buff));
            printf("NkfUsage()=%d len=%d \n%s",sts,len,buff);
        }
        break;
    }
printf("FreeLibrary(lib)\n");
    sts = FreeLibrary(lib);
    if ( sts == 0 ) {
        printf("FreeLibrary() fail\nreturn 1\n");
        return 1;
    }
printf("return 0\n");
    return 0;
}
