# Visual C++ .NET 2003 SP1
CC = cl
LD=link
CFLAGS = -O2 -DMSDOS -DWIN32 -D__WIN32__ -D_CRT_SECURE_NO_DEPRECATE
LD_FLAGS = 
LIBS = user32.lib kernel32.lib gdi32.lib
RC = rc

all: nkf.exe nkfwin.exe nkfdll.exe dbg.exe nkf32.dll

nkf.exe : nkf.obj config.h utf8tbl.obj version.res
	$(CC) $(CFLAGS) nkf.obj utf8tbl.obj version.res /link setargv.obj
	copy nkf.exe WIN\nkf.exe
	copy nkf.exe VC71\nkf.exe

nkf32.dll: nkf32.obj utf8tbldll.obj dll.res
	$(LD) $(LDFLAGS) /DLL /DEF:dll.def nkf32.obj utf8tbldll.obj dll.res
	copy nkf32.dll NT\nkf32.dll
	copy nkf32.lib NT\nkf32.lib
	copy nkf32.dll VC71\NT\nkf32.dll
	copy nkf32.lib VC71\NT\nkf32.lib

nkf32.lib: nkf32.obj utf8tbldll.obj dll.res
	$(LD) $(LDFLAGS) /DLL /DEF:dll.def nkf32.obj utf8tbldll.obj dll.res
	copy nkf32.dll NT\nkf32.dll
	copy nkf32.lib NT\nkf32.lib
	copy nkf32.dll VC71\NT\nkf32.dll
	copy nkf32.lib VC71\NT\nkf32.lib

nkfwin.exe : nkfwin.obj config.h utf8tbl.obj nkf.c utf8tbl.h version.res
	$(CC) $(CFLAGS) nkfwin.obj utf8tbl.obj version.res /link setargv.obj $(LIBS)
	copy nkfwin.exe WIN\nkfwin.exe
	copy nkfwin.exe VC71\nkfwin.exe

nkfdll.exe : nkfdll.obj nkf32.lib
	$(CC) $(CFLAGS) /MT nkfdll.obj nkf32.lib /link $(LIBS)
	copy nkfdll.exe VC71\nkfdll.exe

dbg.exe : dbg.obj utf8tbl.obj
	$(CC) $(CFLAGS) -DDLLDBG -DWIN32DLL -DTOMIME -DGETKANJICODE -DFILECONVERT1 -DFILECONVERT2 -DUNICODESUPPORT dbg.obj utf8tbl.obj /link $(LIBS)
	copy dbg.exe VC71\dbg.exe

nkf.obj : nkf.c utf8tbl.h config.h
	$(CC) $(CFLAGS) -c nkf.c

nkf32.obj: nkf32.c nkf.c utf8tbl.h nkf32dll.c config.h nkf.h
	$(CC) $(CFLAGS) /LD /MT -DWIN32DLL -DTOMIME -DGETKANJICODE -DFILECONVERT1 -DFILECONVERT2 -DUNICODESUPPORT /c nkf32.c

nkfwin.obj : nkfwin.c nkf.c utf8tbl.h config.h
	$(CC) $(CFLAGS) -c nkfwin.c

nkfdll.obj : nkfdll.c nkf.h
	$(CC) $(CFLAGS) /LD /MT -DWIN32DLL -DTOMIME -DGETKANJICODE -DFILECONVERT1 -DFILECONVERT2 -DUNICODESUPPORT /c nkfdll.c

utf8tbl.obj : utf8tbl.c config.h
	$(CC) $(CFLAGS) /c utf8tbl.c

utf8tbldll.obj : utf8tbldll.c utf8tbl.c config.h
	$(CC) $(CFLAGS) /LD /MT /c utf8tbldll.c

version.res: version.rc
    $(RC) $(RCFLAGS) version.rc

dll.res: dll.rc
    $(RC) $(RCFLAGS) dll.rc

clean:
	-del nkf.obj
	-del nkfwin.obj
	-del nkf32.obj
	-del utf8tbl.obj
	-del utf8tbldll.obj
	-del nkfdll.obj
	-del dbg.obj
	-del version.res
	-del dll.res
	-del nkf.exe
	-del nkfwin.exe
	-del nkf32.dll
	-del nkf32.lib
	-del nkfdll.exe
	-del dbg.exe
