#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <windows.h>

#define NKF32103A
/*
#define TOMIME
#define GETKANJICODE
#define FILECONVERT1
#define FILECONVERT2
#include "nkf.h"
*/

/*
nkfdll
*/

unsigned char buff[65536];
unsigned char buff2[65536];
char arg[1024];
char *code[] = {"VtgJIS","EUC","ISO-2022-JP","UTF-8","UTF-16LE","UTF-16BE"};
struct {
    DWORD size;
    LPCSTR copyrightA;
    LPCSTR versionA;
    LPCSTR dateA;
    DWORD functions;
} fnc;

void (CALLBACK *GetNkfVersion)(LPSTR verStr);
int (CALLBACK *SetNkfOption)(LPCSTR optStr);
void (CALLBACK *NkfConvert)(LPSTR outStr, LPCSTR inStr);
void (CALLBACK *ToHankaku)(LPSTR inStr);
void (CALLBACK *ToZenkakuKana)(LPSTR outStr ,LPCSTR inStr);
void (CALLBACK *EncodeSubject)(LPSTR outStr ,LPCSTR inStr);
void (CALLBACK *ToMime)(LPSTR outStr ,LPCSTR inStr);
int (CALLBACK *NkfGetKanjiCode)(VOID);
BOOL (WINAPI *GetNkfVersionSafeA)(LPSTR verStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
BOOL (WINAPI *GetNkfVersionSafeW)(LPWSTR verStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
BOOL (WINAPI *GetNkfSupportFunctions)(void *outStr,DWORD nBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/);
BOOL (WINAPI *NkfConvertSafe)(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/, LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/);
BOOL (WINAPI *ToHankakuSafe)(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/);
BOOL (WINAPI *ToZenkakuKanaSafe)(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/);
BOOL (WINAPI *EncodeSubjectSafe)(LPSTR outStr,DWORD nOutBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/,LPCSTR inStr,DWORD nInBufferLength /*in Bytes*/);
BOOL (WINAPI *GetNkfGuessA)(LPSTR outStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
BOOL (WINAPI *GetNkfGuessW)(LPWSTR outStr,DWORD nBufferLength /*in TCHARs*/,LPDWORD lpTCHARsReturned /*in TCHARs*/);
void (CALLBACK *NkfFileConvert1)(LPCSTR fName);
BOOL (WINAPI *NkfFileConvert1SafeA)(LPCSTR fName,DWORD nBufferLength /*in TCHARs*/);
BOOL (WINAPI *NkfFileConvert1SafeW)(LPCWSTR fName,DWORD nBufferLength /*in TCHARs*/);
void (CALLBACK *NkfFileConvert2)(LPCSTR fInName,LPCSTR fOutName);
BOOL (WINAPI *NkfFileConvert2SafeA)(LPCSTR fInName,DWORD fInBufferLength /*in TCHARs*/,LPCSTR fOutName,DWORD fOutBufferLength /*in TCHARs*/);
BOOL (WINAPI *NkfFileConvert2SafeW)(LPCWSTR fInName,DWORD fInBufferLength /*in TCHARs*/,LPCWSTR fOutName,DWORD fOutBufferLength /*in TCHARs*/);
BOOL (WINAPI *NkfUsage)(LPSTR outStr,DWORD nBufferLength /*in Bytes*/,LPDWORD lpBytesReturned /*in Bytes*/);

#define m(x) { (void (**)())&x , #x }
struct {
    void (**fptr)();
    char *cp;
} fncp[] = {
    m(GetNkfVersion),
    m(SetNkfOption),
    m(NkfConvert),
    m(ToHankaku),
    m(ToZenkakuKana),
    m(EncodeSubject),
    m(ToMime),
    m(NkfGetKanjiCode),
    m(GetNkfVersionSafeA),
    m(GetNkfVersionSafeW),
    m(GetNkfSupportFunctions),
    m(NkfConvertSafe),
    m(ToHankakuSafe),
    m(ToZenkakuKanaSafe),
    m(EncodeSubjectSafe),
    m(GetNkfGuessA),
    m(GetNkfGuessW),
    m(NkfFileConvert1),
    m(NkfFileConvert1SafeA),
    m(NkfFileConvert1SafeW),
    m(NkfFileConvert2),
    m(NkfFileConvert2SafeA),
    m(NkfFileConvert2SafeW),
    m(NkfUsage),
}, *fncp_p;

char *filename;
int df;
int ff;

void dumpn(unsigned char *buff,unsigned n)
{
    int i;
    FILE *fp;

    if ( df == 1 ) {
        i = 0;
        if ( n == 0 ) {
            printf(":%x  len=%d\n",buff,n);
            return;
        }
        while ( n ) {
            if ( i == 0 ) {
                printf(":%x  ",buff);
            }
            printf("%02x ",*buff++);
            i++;
            if ( i == 16 ) {
                printf("\n");
                i = 0;
            }
            n--;
        }
        printf("\n");
    }
    if ( ff == 1 && filename != NULL ) {
        fp = fopen(filename,"wb");
        if ( fp == NULL ) return;
        n = fwrite(buff,1,n,fp);
        fclose(fp);
    }
}

int args(char *cmdline,char **argv)
{
    int argc;
    int c;
    int tc;
    char *p;
    char *q;

    argc = 1;
    *argv = NULL;
    argv++;
    p = cmdline;
    q = arg;
    while ( *p == ' ' ) p++;
    while ( c = *p ) {
        if ( c == '"' ) {
            tc = '"';
            p++;
            c = *p;
            if ( c == 0 ) {
                *q = 0;
                break;
            }
        } else {
            tc = ' ';
        }
        *argv = q;
        argv++;
        argc++;
        while ( c != 0 && c != tc ) {
            *q = c;
            p++;
            c = *p;
            q++;
        }
        *q = 0;
        q++;
        if ( c == tc ) {
            p++;
        }
        while ( *p == ' ' ) p++;
    }
    return argc;
}

void help(void)
{
    printf(
"+: dump on\n"
"-: dump off\n"
"*: dumpfile on\n"
"/: dumpfile off\n"
"= outfile: dumpfile filename\n"
"l: LoadLibrary(nkf32.dll)\n"
"f: FreeLibrary(nkf32.dll)\n"
"v: GetNkfVersion()\n"
"u: NkfUsage()\n"
"m infile [outfile]: ToMime()\n"
"h infile [outfile]: ToHankaku()\n"
"z infile [outfile]: ToZenkakuKana()\n"
"g [outfile]: NkfGetKanjiCode(),GetNkfGuess()\n"
"o option: SetNkfOption(option)\n"
"c infile [outfile]: NkfConvert()\n"
"1 v|a|w in-outfile: NkfFileConvert1\n"
"2 v|a|w infile outfile: NkfFileConvert2\n"
"^Z (EOF): quit\n"
      );
}

void inif(void)
{
    int i;

    for ( i = 0 ; i < sizeof fncp / sizeof fncp[0] ; i++ ) {
        *fncp[i].fptr = NULL;
    }
/*
printf("GetNkfVersion=%p\n",GetNkfVersion);
    GetNkfVersion = NULL;
    SetNkfOption = NULL;
    NkfConvert = NULL;
    ToHankaku = NULL;
    ToZenkakuKana = NULL;
    EncodeSubject = NULL;
    ToMime = NULL;
    NkfGetKanjiCode = NULL;
    GetNkfVersionSafeA = NULL;
    GetNkfVersionSafeW = NULL;
    GetNkfSupportFunctions = NULL;
    NkfConvertSafe = NULL;
    EncodeSubjectSafe = NULL;
    GetNkfGuessA = NULL;
    GetNkfGuessW = NULL;
    NkfFileConvert1 = NULL;
    NkfFileConvert1SafeA = NULL;
    NkfFileConvert1SafeW = NULL;
    NkfFileConvert2 = NULL;
    NkfFileConvert2SafeA = NULL;
    NkfFileConvert2SafeW = NULL;
    NkfUsage = NULL;
*/
}

HMODULE loadlib(void)
{
    HMODULE lib;
    int i;

    lib = LoadLibrary("nkf32.dll");
    printf("LoadLibrary(nkf32.dll)\n");
    if ( lib == NULL ) {
        printf("  fail return NULL\n");
        return NULL;
    }

    for ( i = 0 ; i < sizeof fncp / sizeof fncp[0] ; i++ ) {
        *fncp[i].fptr = (void (*)())GetProcAddress(lib,fncp[i].cp);
        if ( *fncp[i].fptr == NULL ) {
            printf("%s == NULL\n",fncp[i].cp);
        }
    }
/*printf("&GetNkfVersion=%p\n",&GetNkfVersion);
printf("GetNkfVersion=%p\n",GetNkfVersion);
printf("&ToMime=%p\n",&ToMime);
printf("ToMime=%p\n",ToMime);*/
/*
    ToMime = (void (CALLBACK *)(LPSTR,LPCSTR))GetProcAddress(lib,"ToMime");
printf("&ToMime=%p\n",&ToMime);
printf("ToMime=%p\n",ToMime);
    if ( ToMime == NULL ) printf("ToMime == NULL ");
    NkfGetKanjiCode = (int (CALLBACK *)(VOID))GetProcAddress(lib,"NkfGetKanjiCode");
    if ( NkfGetKanjiCode == NULL ) printf("NkfGetKanjiCode == NULL ");
    GetNkfVersionSafeA = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfVersionSafeA");
    if ( GetNkfVersionSafeA == NULL ) printf("GetNkfVersionSafeA == NULL ");
    GetNkfVersionSafeW = (BOOL (WINAPI *)(LPWSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfVersionSafeW");
    if ( GetNkfVersionSafeW == NULL ) printf("GetNkfVersionSafeW == NULL ");
    GetNkfSupportFunctions = (BOOL (WINAPI *)(void *,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfSupportFunctions");
    if ( GetNkfSupportFunctions == NULL ) printf("GetNkfSupportFunctions == NULL ");
    EncodeSubjectSafe = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD,LPCSTR,DWORD))GetProcAddress(lib,"EncodeSubjectSafe");
    if ( EncodeSubjectSafe == NULL ) printf("EncodeSubjectSafe == NULL ");
    NkfConvertSafe = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD, LPCSTR,DWORD))GetProcAddress(lib,"NkfConvertSafe");
    if ( NkfConvertSafe == NULL ) printf("NkfConvertSafe == NULL ");
    GetNkfGuessA = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfGuessA");
    if ( GetNkfGuessA == NULL ) printf("GetNkfGuessA == NULL ");
    GetNkfGuessW = (BOOL (WINAPI *)(LPWSTR,DWORD,LPDWORD))GetProcAddress(lib,"GetNkfGuessW");
    if ( GetNkfGuessW == NULL ) printf("GetNkfGuessW == NULL ");
    NkfFileConvert1 = (void (CALLBACK *)(LPCSTR))GetProcAddress(lib,"NkfFileConvert1");
    if ( NkfFileConvert1 == NULL ) printf("NkfFileConvert1 == NULL ");
    NkfFileConvert1SafeA = (BOOL (WINAPI *)(LPCSTR,DWORD))GetProcAddress(lib,"NkfFileConvert1SafeA");
    if ( NkfFileConvert1SafeA == NULL ) printf("NkfFileConvert1SafeA == NULL ");
    NkfFileConvert1SafeW = (BOOL (WINAPI *)(LPCWSTR,DWORD))GetProcAddress(lib,"NkfFileConvert1SafeW");
    if ( NkfFileConvert1SafeW == NULL ) printf("NkfFileConvert1SafeW == NULL ");
    NkfFileConvert2 = (void (CALLBACK *)(LPCSTR,LPCSTR))GetProcAddress(lib,"NkfFileConvert2");
    if ( NkfFileConvert2 == NULL ) printf("NkfFileConvert2 == NULL ");
    NkfFileConvert2SafeA = (BOOL (WINAPI *)(LPCSTR,DWORD,LPCSTR,DWORD))GetProcAddress(lib,"NkfFileConvert2SafeA");
    if ( NkfFileConvert2SafeA == NULL ) printf("NkfFileConvert2SafeA == NULL ");
    NkfFileConvert2SafeW = (BOOL (WINAPI *)(LPCWSTR,DWORD,LPCWSTR,DWORD))GetProcAddress(lib,"NkfFileConvert2SafeW");
    if ( NkfFileConvert2SafeW== NULL ) printf("NkfFileConvert2SafeW == NULL ");
    NkfUsage = (BOOL (WINAPI *)(LPSTR,DWORD,LPDWORD))GetProcAddress(lib,"NkfUsage");
    if ( NkfUsage == NULL ) printf("NkfUsage == NULL ");
    printf("\n");
*/
    return lib;
}

int filein(char *ifile,unsigned char *buf,int size)
{
    FILE *fp;
    int len;

    if ( (fp = fopen(ifile,"rb") ) != NULL ) {
        len = fread(buf,1,size,fp);
        fclose(fp);
        *(buf + len) = 0;
        return len;
    }
    return EOF;
}

void fileout(char *ofile,unsigned char *buf,int len)
{
    FILE *fp;

    if ( (fp = fopen(ofile,"wb") ) != NULL ) {
        fwrite(buf,1,len,fp);
        fclose(fp);
    }
}

#define err(x) printf(#x " == NULL\n")

void setfilename(int argc,char **argv)
{
    if ( argc < 3 ) return;
    if ( filename != NULL ) {
        free(filename);
    }
    filename = strdup(argv[2]);
    printf("dump file name=%s\n",filename);
}

void version(int argc,char **argv)
{
    DWORD len;
    int sts;

    memset(buff,0,sizeof buff);
    if ( GetNkfVersion != NULL ) {
        GetNkfVersion(buff);
        printf("GetNkfVersion() '%s'\n",buff);
        if ( argc >= 3 ) {
           fileout(argv[2],buff,strlen(buff));
        }
    } else err(GetNkfVersion);
    if ( GetNkfVersionSafeA != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfVersionSafeA(buff,sizeof buff,&len);
        printf("GetNkfVersionSafeA()=%d len=%d '%s'\n",sts,len,buff);
    } else err(GetNkfVersionSafeA);
    if ( GetNkfVersionSafeW != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfVersionSafeW((LPWSTR)buff,sizeof buff / sizeof(WCHAR),&len);
        printf("GetNkfVersionSafeW()=%d len=%d\n",sts,len);
        dumpn(buff,len * sizeof(WCHAR));
    } else err(GetNkfVersionSafeW);
    if ( GetNkfSupportFunctions != NULL ) {
        len = 0;
        sts = GetNkfSupportFunctions(&fnc,sizeof fnc,&len);
        printf("GetNkfSupportFunctions()=%d len=%d\n",sts,len);
        printf("size=%u\n",fnc.size);
        printf("copyrightA='%s'\n",fnc.copyrightA);
        printf("versionA='%s'\n",fnc.versionA);
        printf("dateA='%s'\n",fnc.dateA);
        printf("functions=%d %x\n",fnc.functions,fnc.functions);
    } else err(GetNkfSupportFunctions);
}

void usage(int argc,char **argv)
{
    DWORD len;
    int sts;

    if ( NkfUsage != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = NkfUsage(buff,sizeof buff,&len);
        printf("strlen(buff)=%d\n",strlen(buff));
        printf("NkfUsage()=%d len=%d \n%s",sts,len,buff);
        if ( argc >= 3 ) {
           fileout(argv[2],buff,strlen(buff));
        }
    } else err(NkfUsage);
}

void tomime(int argc,char **argv)
{
    int l;
    DWORD len;
    int sts;

    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    if ( EncodeSubject != NULL ) {
        memset(buff2,0,sizeof buff2);
        printf("EncodeSubject(%s)=",buff);
        EncodeSubject(buff2,buff);
        printf("%s\n",buff2);
        dumpn(buff2,strlen(buff2));
        if ( argc >= 4 ) {
           fileout(argv[3],buff2,strlen(buff2));
        }
    } else err(EncodeSubject);
    if ( ToMime != NULL ) {
        memset(buff2,0,sizeof buff2);
        printf("ToMime(%s)=",buff);
        ToMime(buff2,buff);
        printf("%s\n",buff2);
        dumpn(buff2,strlen(buff2));
    } else err(ToMime);
    if ( EncodeSubjectSafe != NULL ) {
        memset(buff2,0,sizeof buff2);
        len = 0;
        printf("EncodeSubjectSafe(%s)=",buff);
        sts = EncodeSubjectSafe(buff2,sizeof buff2,&len,buff,l);
        printf("%d len=%d '%s'\n",sts,len,buff2);
        dumpn(buff2,len);
    } else err(EncodeSubjectSafe);
}

void tohankaku(int argc,char **argv)
{
    int l;
    DWORD len;
    int sts;

    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    if ( ToHankaku!= NULL ) {
        printf("ToHankaku(%s)=",buff);
        ToHankaku(buff);
        printf("%s\n",buff);
        dumpn(buff,strlen(buff));
        if ( argc >= 4 ) {
           fileout(argv[3],buff,strlen(buff));
        }
    } else err(ToHankaku);
    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    if ( ToHankakuSafe != NULL ) {
        memset(buff2,0,sizeof buff2);
        printf("ToHankakuSafe(%s)=",buff);
        sts = ToHankakuSafe(buff2,sizeof buff2,&len,buff,l);
        printf("%d len=%d '%s'\n",sts,len,buff2);
        dumpn(buff2,len);
    } else err(ToHankakuSafe);
}

void tozenkaku(int argc,char **argv)
{
    int l;
    DWORD len;
    int sts;

    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    if ( ToZenkakuKana!= NULL ) {
        memset(buff2,0,sizeof buff2);
        printf("ToZenkakuKana(%s)=",buff);
        ToZenkakuKana(buff2,buff);
        printf("%s\n",buff2);
        dumpn(buff2,strlen(buff2));
        if ( argc >= 4 ) {
           fileout(argv[3],buff2,strlen(buff2));
        }
    } else err(ToZenkakuKana);
    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    if ( ToZenkakuKanaSafe != NULL ) {
        memset(buff2,0,sizeof buff2);
        printf("ToZenkakuKanaSafe(%s)=",buff);
        sts = ToZenkakuKanaSafe(buff2,sizeof buff2,&len,buff,l);
        printf("%d len=%d '%s'\n",sts,len,buff2);
        dumpn(buff2,len);
    } else err(ToZenkakuKanaSafe);
}

void convert(int argc,char **argv)
{
    int l;
    DWORD len;
    int sts;

    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    dumpn(buff,l);
    if ( NkfConvertSafe != NULL ) {
        memset(buff2,0,sizeof buff2);
        len = 0;
        printf("-=NkfConvertSafe(%p,%d,%p,%d)=-\n",buff2,sizeof buff2,buff,l);
        printf("%s\n=-out-=\n",buff);
        sts = NkfConvertSafe(buff2,sizeof buff2,&len,buff,l);
        printf("%s\n=--=\n",buff2);
        printf("%d len=%d\n",sts,len);
        if ( argc >= 4 ) {
           fileout(argv[3],buff2,strlen(buff2));
        }
        dumpn(buff2,len);
    }
}

void convertsafe(int argc,char **argv)
{
    int l;
    DWORD len;
    int sts;

    if ( argc >= 3 ) {
        l = filein(argv[2],buff,sizeof buff);
    } else return;
    dumpn(buff,l);
    if ( NkfConvertSafe != NULL ) {
        memset(buff2,0,sizeof buff2);
        len = 0;
        printf("-=NkfConvertSafe(%p,%d,%p,%d)=-\n",buff2,sizeof buff2,buff,l);
        printf("%s\n=-out-=\n",buff);
        sts = NkfConvertSafe(buff2,sizeof buff2,&len,buff,l);
        printf("%s\n=--=\n",buff2);
        printf("%d len=%d\n",sts,len);
        if ( argc >= 4 ) {
           fileout(argv[3],buff2,len);
        }
        dumpn(buff2,len);
    }
}

void guess(int argc,char **argv)
{
    int n;
    DWORD len;
    int sts;

    if ( NkfGetKanjiCode != NULL ) {
        n = NkfGetKanjiCode();
        printf("NkfGetKanjiCode()=%d %s\n",n,code[n]);
    }
    if ( GetNkfGuessA != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfGuessA(buff,sizeof buff,&len);
        printf("GetNkfGuessA()=%d len=%d '%s'\n",sts,len,buff);
        dumpn(buff,len);
        if ( argc >= 3 ) {
           fileout(argv[2],buff2,strlen(buff2));
        }
    }
    if ( GetNkfGuessW != NULL ) {
        memset(buff,0,sizeof buff);
        len = 0;
        sts = GetNkfGuessW((LPWSTR)buff,sizeof buff / sizeof(WCHAR),&len);
        printf("GetNkfGuessW()=%d len=%d\n",sts,len);
        dumpn(buff,len * sizeof(WCHAR));
    }
}

void option(int argc,char **argv)
{
    int n;
    DWORD len;
    int sts;

    if ( argc < 3 ) return;
    if ( SetNkfOption != NULL ) {
        sts = SetNkfOption(argv[2]);
        printf("SetNkfOption()=%d\n",sts);
    }
}

void file1(int argc,char **argv)
{
    int sts;
    wchar_t uniname[MAX_PATH + 1];

    if ( argc < 4 ) return;
    switch ( *argv[2] ) {
      case 'v':
        if ( NkfFileConvert1 != NULL ) {
            NkfFileConvert1(argv[3]);
        }
        break;
      case 'a':
        if ( NkfFileConvert1SafeA != NULL ) {
            sts = NkfFileConvert1SafeA(argv[3],strlen(argv[3]));
        }
        printf("sts=%d\n",sts);
        break;
      case 'w':
        if ( NkfFileConvert1SafeW != NULL ) {
            MultiByteToWideChar(CP_OEMCP,MB_PRECOMPOSED,argv[3],-1,uniname,sizeof uniname);
            sts = NkfFileConvert1SafeW(uniname,wcslen(uniname)+1);
        }
        printf("sts=%d\n",sts);
        break;
      default:
        printf("default:\n");
        break;
    }
}

void file2(int argc,char **argv)
{
    int sts;
    wchar_t uninamei[MAX_PATH + 1];
    wchar_t uninameo[MAX_PATH + 1];

    if ( argc < 4 ) return;
    switch ( *argv[2] ) {
      case 'v':
        if ( NkfFileConvert2 != NULL ) {
            NkfFileConvert2(argv[3],argv[4]);
        }
        break;
      case 'a':
        if ( NkfFileConvert2SafeA != NULL ) {
            sts = NkfFileConvert2SafeA(argv[3],strlen(argv[3]) + 1,argv[4],strlen(argv[4]) + 1);
        }
        printf("sts=%d\n",sts);
        break;
      case 'w':
        if ( NkfFileConvert1SafeW != NULL ) {
            MultiByteToWideChar(CP_OEMCP,MB_PRECOMPOSED,argv[3],-1,uninamei,sizeof uninamei);
            MultiByteToWideChar(CP_OEMCP,MB_PRECOMPOSED,argv[4],-1,uninameo,sizeof uninameo);
            sts = NkfFileConvert2SafeW(uninamei,wcslen(uninamei)+1,uninameo,wcslen(uninameo)+1);
        }
        printf("sts=%d\n",sts);
        break;
      default:
        printf("default:\n");
        break;
    }
}

int main(int ac,char **av)
{
    HMODULE lib;
    int libf;
    char cmd[1025];
    int l;
    int argc;
    char *argv[10];
    int sts;

    printf("start nkfdll - debug nkf32.dll\n");
    help();
    libf = 0;
    inif();
    while ( gets(cmd) ) {
        argc = args(cmd,argv);
        switch ( cmd[0] ) {
          case '+':
            df = 1;
            break;
          case '-':
            df = 0;
            break;
          case '*':
            ff = 1;
            break;
          case '/':
            ff = 0;
            break;
          case '=':
            setfilename(argc,argv);
            break;
          case 'l':
            if ( libf == 0 ) {
                lib = loadlib();
                if ( lib != 0 ) {
                    libf = 1;
                }
            } else {
                printf("libf=%d lib=%d\n",libf,lib);
            }
            break;
          case 'f':
            printf("FreeLibrary(lib)\n");
            sts = FreeLibrary(lib);
            if ( sts != 0 ) {
                libf = 0;
                inif();
            } else {
                printf("FreeLibrary() fail %d\n",GetLastError());
            }
            break;
          case 'v':
            version(argc,argv);
            break;
          case 'u':
            usage(argc,argv);
            break;
          case 'm':
            tomime(argc,argv);
            break;
          case 'h':
            tohankaku(argc,argv);
            break;
          case 'z':
            tozenkaku(argc,argv);
            break;
          case 'g':
            guess(argc,argv);
            break;
          case 'o':
            option(argc,argv);
            break;
          case 'c':
            convert(argc,argv);
            break;
          case 'C':
            convertsafe(argc,argv);
            break;
          case '1':
            file1(argc,argv);
            break;
          case '2':
            file2(argc,argv);
            break;
          default:
            help();
            break;
        }
    }
    if ( libf != 0 ) {
        sts = FreeLibrary(lib);
        if ( sts != 0 ) {
            printf("FreeLibrary(lib)\n");
        } else {
            printf("FreeLibrary() fail %d\n",GetLastError());
        }
    }
    printf("return 0\n");
    return 0;
}
